'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactFontawesome = require('@fortawesome/react-fontawesome');

var _proLightSvgIcons = require('@fortawesome/pro-light-svg-icons');

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _uiComponentsCalendar = require('@ideco/ui-components-calendar');

var _uiComponentsCalendar2 = _interopRequireDefault(_uiComponentsCalendar);

var _index = require('../SchedulingMoveInDate/index');

var _index2 = _interopRequireDefault(_index);

var _index3 = require('../SchedulingFooter/index');

var _index4 = _interopRequireDefault(_index3);

var _SchedulingDateModule = require('./SchedulingDate.module.scss');

var _SchedulingDateModule2 = _interopRequireDefault(_SchedulingDateModule);

var _helperMethods = require('../helperMethods');

var _constants = require('../constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DATE_OPTIONS = {
  MOVE_IN_DATE: 1,
  AFTER_DAY_MOVE_IN: 2,
  CUSTOM_DATE: 3
};

var SchedulingDate = function (_React$Component) {
  (0, _inherits3.default)(SchedulingDate, _React$Component);

  function SchedulingDate(props) {
    (0, _classCallCheck3.default)(this, SchedulingDate);

    var _this = (0, _possibleConstructorReturn3.default)(this, (SchedulingDate.__proto__ || Object.getPrototypeOf(SchedulingDate)).call(this));

    _initialiseProps.call(_this);

    var moveInDate = (0, _moment2.default)(props.moveInDate).clone();
    _this.afterMoveInDate = moveInDate.add(1, 'days').toISOString();

    _this.state = {
      currentDateOption: null,
      currentDateModalState: props.currentDateModalState,
      date: props.date
    };
    return _this;
  }

  (0, _createClass3.default)(SchedulingDate, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          moveInDate = _props.moveInDate,
          subTitle = _props.subTitle,
          logo = _props.logo,
          isSubmitModal = _props.isSubmitModal,
          calendar = _props.calendar,
          theme = _props.theme;
      var _state = this.state,
          currentDateOption = _state.currentDateOption,
          currentDateModalState = _state.currentDateModalState,
          date = _state.date;

      var isSelectedValue = !!currentDateOption;

      if (currentDateModalState === _constants.DATE_MODAL_STATE.CALENDAR) {
        isSelectedValue = !!date;
      }

      return _react2.default.createElement(
        'div',
        { className: _SchedulingDateModule2.default.container },
        _react2.default.createElement(
          'div',
          { className: _SchedulingDateModule2.default.cancelButtonWrapper },
          _react2.default.createElement(
            'button',
            {
              type: 'button',
              className: _SchedulingDateModule2.default.cancelButton,
              onClick: this.handleCancelButtonClick
            },
            _react2.default.createElement(_reactFontawesome.FontAwesomeIcon, { icon: _proLightSvgIcons.faTimes, className: _SchedulingDateModule2.default.cancelButton__icon })
          )
        ),
        _react2.default.createElement(_index2.default, { date: moveInDate, theme: theme }),
        _react2.default.createElement(
          'div',
          { className: _SchedulingDateModule2.default.header },
          _react2.default.createElement(
            'div',
            { className: _SchedulingDateModule2.default.LogoWrapper },
            _react2.default.createElement('img', { className: _SchedulingDateModule2.default.logo, src: logo.link, alt: 'logo of ' + logo.name + ' provider' })
          ),
          _react2.default.createElement(
            'span',
            { className: _SchedulingDateModule2.default.header__title },
            'Select a Date'
          ),
          _react2.default.createElement(
            'span',
            { className: _SchedulingDateModule2.default.header__subTitle },
            subTitle
          )
        ),
        _react2.default.createElement(
          'div',
          { className: _SchedulingDateModule2.default.selection },
          !!(currentDateModalState === _constants.DATE_MODAL_STATE.DATE) && _react2.default.createElement(
            'ul',
            { className: _SchedulingDateModule2.default.selection__list },
            _react2.default.createElement(
              'li',
              { className: _SchedulingDateModule2.default.selection__item },
              _react2.default.createElement('input', {
                className: _SchedulingDateModule2.default.selection__itemInput,
                type: 'radio',
                id: 'move-in-day-option',
                name: 'selector',
                value: DATE_OPTIONS.MOVE_IN_DATE,
                onChange: this.handleDateOptionChange
              }),
              _react2.default.createElement(
                'label',
                { className: _SchedulingDateModule2.default.selection__itemLabel, htmlFor: 'move-in-day-option' },
                _react2.default.createElement(
                  'span',
                  { className: _SchedulingDateModule2.default.selection__labelImportant },
                  'Move-in Day,'
                ),
                ' ',
                (0, _helperMethods.getDateString)((0, _moment2.default)(moveInDate))
              )
            ),
            _react2.default.createElement(
              'li',
              { className: _SchedulingDateModule2.default.selection__item },
              _react2.default.createElement('input', {
                className: _SchedulingDateModule2.default.selection__itemInput,
                type: 'radio',
                id: 'day-after-move-in-option',
                name: 'selector',
                value: DATE_OPTIONS.AFTER_DAY_MOVE_IN,
                onChange: this.handleDateOptionChange
              }),
              _react2.default.createElement(
                'label',
                { className: _SchedulingDateModule2.default.selection__itemLabel, htmlFor: 'day-after-move-in-option' },
                _react2.default.createElement(
                  'span',
                  { className: _SchedulingDateModule2.default.selection__labelImportant },
                  'Day After Move-in,'
                ),
                ' ',
                (0, _helperMethods.getDateString)((0, _moment2.default)(this.afterMoveInDate))
              )
            ),
            _react2.default.createElement(
              'li',
              { className: _SchedulingDateModule2.default.selection__item },
              _react2.default.createElement('input', {
                className: _SchedulingDateModule2.default.selection__itemInput,
                type: 'radio',
                id: 'different-day-option',
                name: 'selector',
                value: DATE_OPTIONS.CUSTOM_DATE,
                onChange: this.handleDateOptionChange
              }),
              _react2.default.createElement(
                'label',
                { className: _SchedulingDateModule2.default.selection__itemLabel, htmlFor: 'different-day-option' },
                'Choose a different installation day'
              )
            )
          ),
          !!(currentDateModalState === _constants.DATE_MODAL_STATE.CALENDAR) && _react2.default.createElement(_uiComponentsCalendar2.default, {
            value: moveInDate,
            selectedDate: date,
            onChangeDate: this.handleCalendarDateChange,
            disabledDate: calendar.disabledDate,
            theme: theme
          })
        ),
        _react2.default.createElement(_index4.default, {
          valueSet: 'Set Date',
          isSelectedValue: isSelectedValue,
          onSubmit: this.handleSubmit,
          onClickBackButton: this.handleBackButtonClick,
          isSubmitModal: isSubmitModal,
          customClassName: _SchedulingDateModule2.default.footer,
          theme: theme
        })
      );
    }
  }]);
  return SchedulingDate;
}(_react2.default.Component);

var _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.handleDateOptionChange = function (event) {
    var value = parseInt(event.target.value, 10);
    var isSubmitModal = _this2.props.isSubmitModal;


    if (isSubmitModal) {
      _this2.setState({
        currentDateOption: value
      });
    } else {
      _this2.handleSetDate(value);
    }
  };

  this.handleSubmit = function () {
    var currentDateOption = _this2.state.currentDateOption;

    _this2.handleSetDate(currentDateOption);
  };

  this.handleSetDate = function (currentDateOption) {
    var currentDateModalState = _this2.state.currentDateModalState;
    var setDate = _this2.props.setDate;


    if (currentDateModalState === _constants.DATE_MODAL_STATE.DATE) {
      if (currentDateOption === DATE_OPTIONS.MOVE_IN_DATE) {
        var moveInDate = _this2.props.moveInDate;

        setDate(moveInDate, currentDateModalState);
      } else if (currentDateOption === DATE_OPTIONS.AFTER_DAY_MOVE_IN) {
        setDate(_this2.afterMoveInDate, currentDateModalState);
      } else if (currentDateOption === DATE_OPTIONS.CUSTOM_DATE) {
        _this2.setState({
          currentDateOption: null,
          currentDateModalState: _constants.DATE_MODAL_STATE.CALENDAR
        });
      }
    } else if (currentDateModalState === _constants.DATE_MODAL_STATE.CALENDAR) {
      var date = _this2.state.date;

      setDate(date, currentDateModalState);
    }
  };

  this.handleBackButtonClick = function () {
    var currentDateModalState = _this2.state.currentDateModalState;


    if (currentDateModalState === _constants.DATE_MODAL_STATE.DATE) {
      _this2.props.onClickBackButton();
    } else if (currentDateModalState === _constants.DATE_MODAL_STATE.CALENDAR) {
      _this2.setState({ currentDateModalState: _constants.DATE_MODAL_STATE.DATE });
    }
  };

  this.handleCalendarDateChange = function (date) {
    var isSubmitModal = _this2.props.isSubmitModal;
    var currentDateModalState = _this2.state.currentDateModalState;


    if (isSubmitModal) {
      _this2.setState({ date: date });
    } else {
      var setDate = _this2.props.setDate;

      setDate(date, currentDateModalState);
    }
  };

  this.handleCancelButtonClick = function (event) {
    _this2.props.onCloseModal();
  };
};

SchedulingDate.defaultProps = {
  isSubmitModal: true,
  date: null,
  currentDateModalState: _constants.DATE_MODAL_STATE.DATE,
  calendar: {
    disabledDate: function disabledDate() {
      return false;
    }
  }
};

exports.default = SchedulingDate;