'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactModal = require('react-modal');

var _reactModal2 = _interopRequireDefault(_reactModal);

var _SchedulingModalModule = require('./SchedulingModal.module.scss');

var _SchedulingModalModule2 = _interopRequireDefault(_SchedulingModalModule);

var _constants = require('../constants');

var _SchedulingDate = require('../SchedulingDate/SchedulingDate');

var _SchedulingDate2 = _interopRequireDefault(_SchedulingDate);

var _SchedulingTime = require('../SchedulingTime/SchedulingTime');

var _SchedulingTime2 = _interopRequireDefault(_SchedulingTime);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var customStyles = {
  content: {
    top: '50%',
    left: '50%',
    right: 'auto',
    bottom: 'auto',
    padding: '0',
    marginRight: '-50%',
    transform: 'translate(-50%, -50%)',
    width: 'cacl(100% - 10%)'
  },
  overlay: {
    backgroundColor: 'rgba(0, 0, 0, 0.6)',
    width: '100%',
    zIndex: '9999'
  }
};

if (document && document.getElementById('#root')) {
  _reactModal2.default.setAppElement('#root');
}

var SchedulingModal = function (_React$Component) {
  (0, _inherits3.default)(SchedulingModal, _React$Component);

  function SchedulingModal(props) {
    (0, _classCallCheck3.default)(this, SchedulingModal);

    var _this = (0, _possibleConstructorReturn3.default)(this, (SchedulingModal.__proto__ || Object.getPrototypeOf(SchedulingModal)).call(this));

    _this.handleSetDate = function (date, currentDateModalState) {
      var timeRange = _this.props.timeRange;


      if (!timeRange) {
        _this.props.onSubmitModal({ date: date, time: null, notes: '' });
      } else {
        _this.setState({
          date: date,
          modalState: _constants.SCHEDULING_MODAL_STATE.TIME,
          currentDateModalState: currentDateModalState
        });
      }
    };

    _this.handleSetTime = function (_ref) {
      var time = _ref.time,
          notes = _ref.notes;
      var date = _this.state.date;

      _this.props.onSubmitModal({ date: date, time: time, notes: notes });
    };

    _this.handleBackButtonClickFromDate = function () {
      _this.props.onCloseModal();
    };

    _this.handleBackButtonClickFromTime = function () {
      _this.setState({
        modalState: _constants.SCHEDULING_MODAL_STATE.DATE
      });
    };

    _this.handleModalClose = function (event) {
      _this.props.onCloseModal();
    };

    _this.state = {
      modalState: _constants.SCHEDULING_MODAL_STATE.DATE,
      date: props.date,
      notes: props.notes,
      currentDateModalState: _constants.DATE_MODAL_STATE.DATE
    };
    return _this;
  }

  (0, _createClass3.default)(SchedulingModal, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          isModalOpen = _props.isModalOpen,
          moveInDate = _props.moveInDate,
          stepName = _props.stepName,
          subTitle = _props.subTitle,
          logo = _props.logo,
          calendar = _props.calendar,
          theme = _props.theme,
          timeRange = _props.timeRange;
      var _state = this.state,
          modalState = _state.modalState,
          date = _state.date,
          currentDateModalState = _state.currentDateModalState,
          notes = _state.notes;


      return _react2.default.createElement(
        'div',
        { className: _SchedulingModalModule2.default.container },
        _react2.default.createElement(
          _reactModal2.default,
          { isOpen: isModalOpen, style: customStyles, contentLabel: 'Example Modal' },
          modalState === _constants.SCHEDULING_MODAL_STATE.DATE && _react2.default.createElement(_SchedulingDate2.default, {
            stepName: stepName,
            onClickBackButton: this.handleBackButtonClickFromDate,
            moveInDate: moveInDate,
            subTitle: subTitle,
            setDate: this.handleSetDate,
            logo: logo,
            onCloseModal: this.handleModalClose,
            isSubmitModal: !timeRange,
            date: date,
            currentDateModalState: currentDateModalState,
            calendar: calendar,
            theme: theme
          }),
          timeRange && modalState === _constants.SCHEDULING_MODAL_STATE.TIME && _react2.default.createElement(_SchedulingTime2.default, {
            stepName: stepName,
            onClickBackButton: this.handleBackButtonClickFromTime,
            subTitle: subTitle,
            setTime: this.handleSetTime,
            logo: logo,
            onCloseModal: this.handleModalClose,
            date: date,
            notes: notes,
            theme: theme,
            timeRange: timeRange
          })
        )
      );
    }
  }]);
  return SchedulingModal;
}(_react2.default.Component);

SchedulingModal.defaultProps = {
  notes: '',
  date: null,
  calendar: null
};

exports.default = SchedulingModal;