'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactFontawesome = require('@fortawesome/react-fontawesome');

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _uiComponentsButton = require('@ideco/ui-components-button');

var _uiComponentsButton2 = _interopRequireDefault(_uiComponentsButton);

var _omit = require('lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

var _SchedulingStepModule = require('./SchedulingStep.module.scss');

var _SchedulingStepModule2 = _interopRequireDefault(_SchedulingStepModule);

var _SchedulingModal = require('../SchedulingModal/SchedulingModal');

var _SchedulingModal2 = _interopRequireDefault(_SchedulingModal);

var _helperMethods = require('../helperMethods');

var _constants = require('../constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SchedulingStep = function (_React$Component) {
  (0, _inherits3.default)(SchedulingStep, _React$Component);

  function SchedulingStep(props) {
    (0, _classCallCheck3.default)(this, SchedulingStep);

    var _this = (0, _possibleConstructorReturn3.default)(this, (SchedulingStep.__proto__ || Object.getPrototypeOf(SchedulingStep)).call(this));

    _this.handleSetDateTimeButtonClick = function (event) {
      _this.setState({ isModalOpen: true });
    };

    _this.handleModalSubmit = function (_ref) {
      var date = _ref.date,
          time = _ref.time,
          notes = _ref.notes;
      var type = _this.props.type;


      _this.setState({
        isModalOpen: false
      });

      var result = {
        type: type
      };

      if (time) {
        result.payload = {
          date: date,
          timerange: time.value,
          notes: notes
        };
      } else {
        result.payload = {
          date: date
        };
      }

      _this.props.setDataForStep(result);
    };

    _this.getActionButtonText = function () {
      var timeRange = _this.props.timeRange;
      var _this$state = _this.state,
          date = _this$state.date,
          time = _this$state.time;


      var actionButtonText = 'Set Date';

      if (timeRange && date && time) {
        actionButtonText = 'Edit';
      } else if (!timeRange && date) {
        actionButtonText = 'Edit';
      }

      return actionButtonText;
    };

    _this.handleCloseModal = function () {
      _this.setState({ isModalOpen: false });
    };

    _this.getErrorsComponent = function (errors) {
      if (!errors) {
        return null;
      }

      return _react2.default.createElement(
        'div',
        { className: _SchedulingStepModule2.default.errors },
        errors.map(function (error) {
          return _react2.default.createElement(
            'span',
            { key: error, className: _SchedulingStepModule2.default.error },
            error
          );
        })
      );
    };

    _this.getErrorsFieldComponent = function (field) {
      var errorsFiledComponent = null;

      if (field) {
        errorsFiledComponent = _this.getErrorsComponent(field.errors);
      }

      return errorsFiledComponent;
    };

    _this.getDataInfo = function () {
      for (var _len = arguments.length, items = Array(_len), _key = 0; _key < _len; _key++) {
        items[_key] = arguments[_key];
      }

      var itemsWithData = items.filter(function (item) {
        return item && (item.value || item.errors || item.description);
      });

      if (!itemsWithData.length) {
        return null;
      }

      var component = _react2.default.createElement(
        'div',
        { className: _SchedulingStepModule2.default.dataInfo },
        itemsWithData.map(function (item) {
          var errorsComponent = _this.getErrorsFieldComponent(item);

          return _react2.default.createElement(
            'div',
            { className: _SchedulingStepModule2.default.dataInfo__item, key: item.label },
            (!!item.value || !!item.errors || !!item.description) && _react2.default.createElement(
              'span',
              { className: _SchedulingStepModule2.default.dataInfo__itemLabel },
              item.label
            ),
            !!item.value && _react2.default.createElement(
              'span',
              { className: _SchedulingStepModule2.default.dataInfo__itemValue },
              item.value
            ),
            !!item.description && _react2.default.createElement(
              'span',
              { className: _SchedulingStepModule2.default.description },
              item.description
            ),
            errorsComponent
          );
        })
      );

      return component;
    };

    _this.state = {
      isModalOpen: false
    };
    return _this;
  }

  (0, _createClass3.default)(SchedulingStep, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          stepName = _props.stepName,
          moveInDate = _props.moveInDate,
          icon = _props.icon,
          subTitle = _props.subTitle,
          logo = _props.logo,
          calendar = _props.calendar,
          customClassName = _props.customClassName,
          theme = _props.theme,
          isDisabledStep = _props.isDisabledStep,
          timeRange = _props.timeRange,
          date = _props.date,
          time = _props.time,
          notes = _props.notes;
      var isModalOpen = this.state.isModalOpen;


      if (date && date.value) {
        date.value = (0, _helperMethods.getDateString)((0, _moment2.default)(date.value));
      }

      if (date) {
        date.label = 'Date:';
      }

      if (time) {
        time.label = 'Time:';
      }

      if (notes) {
        notes.label = 'Notes:';
      }

      var actionButtonText = this.getActionButtonText();
      var dataInfoComponent = this.getDataInfo(date, time, notes);

      return _react2.default.createElement(
        'div',
        { className: (0, _classnames2.default)(_SchedulingStepModule2.default.container, customClassName) },
        _react2.default.createElement(
          'div',
          { className: _SchedulingStepModule2.default.content },
          _react2.default.createElement(
            'div',
            { className: _SchedulingStepModule2.default.contentHeader },
            _react2.default.createElement(
              'div',
              { className: _SchedulingStepModule2.default.contentHeader__data },
              _react2.default.createElement(
                'div',
                { className: _SchedulingStepModule2.default.contentHeader__iconWrapper },
                _react2.default.createElement(_reactFontawesome.FontAwesomeIcon, { className: (0, _classnames2.default)(_SchedulingStepModule2.default.contentHeader__icon, 'fas'), icon: icon })
              ),
              _react2.default.createElement(
                'span',
                { className: _SchedulingStepModule2.default.contentHeader__label },
                stepName
              )
            ),
            _react2.default.createElement(
              'div',
              { className: _SchedulingStepModule2.default.contentHeader__actionButtonWrapper },
              _react2.default.createElement(
                _uiComponentsButton2.default,
                {
                  styleType: _constants.BUTTON_STYLE_TYPE.LINK,
                  onClick: this.handleSetDateTimeButtonClick,
                  className: _SchedulingStepModule2.default.actionButton,
                  theme: theme,
                  color: _constants.BUTTON_COLOR.BLUE,
                  disabled: isDisabledStep
                },
                actionButtonText
              )
            )
          ),
          !!dataInfoComponent && dataInfoComponent
        ),
        !!isModalOpen && _react2.default.createElement(_SchedulingModal2.default, {
          moveInDate: moveInDate,
          isModalOpen: isModalOpen,
          onCloseModal: this.handleCloseModal,
          onSubmitModal: this.handleModalSubmit,
          stepName: stepName,
          subTitle: subTitle,
          logo: logo,
          date: date ? date.value : null,
          notes: notes ? notes.value : null,
          calendar: calendar,
          theme: theme,
          timeRange: timeRange
        })
      );
    }
  }]);
  return SchedulingStep;
}(_react2.default.Component);

SchedulingStep.defaultProps = {
  date: null,
  time: null,
  notes: '',
  customClassName: '',
  isDisabledStep: false,
  timeRange: null,
  calendar: null
};

exports.default = SchedulingStep;