'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactFontawesome = require('@fortawesome/react-fontawesome');

var _proLightSvgIcons = require('@fortawesome/pro-light-svg-icons');

var _index = require('../SchedulingMoveInDate/index');

var _index2 = _interopRequireDefault(_index);

var _index3 = require('../SchedulingFooter/index');

var _index4 = _interopRequireDefault(_index3);

var _SchedulingTimeModule = require('./SchedulingTime.module.scss');

var _SchedulingTimeModule2 = _interopRequireDefault(_SchedulingTimeModule);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SchedulingTime = function (_React$PureComponent) {
  (0, _inherits3.default)(SchedulingTime, _React$PureComponent);

  function SchedulingTime(props) {
    (0, _classCallCheck3.default)(this, SchedulingTime);

    var _this = (0, _possibleConstructorReturn3.default)(this, (SchedulingTime.__proto__ || Object.getPrototypeOf(SchedulingTime)).call(this));

    _this.handleTimeOptionChange = function (value) {
      return function (event) {
        var timeRange = _this.props.timeRange;


        var currentOption = timeRange.options.find(function (option) {
          return option.value === value;
        });

        _this.setState({
          currentOption: currentOption
        });
      };
    };

    _this.handleSubmit = function () {
      var _this$state = _this.state,
          notes = _this$state.notes,
          currentOption = _this$state.currentOption;
      var setTime = _this.props.setTime;


      setTime({ time: currentOption, notes: notes });
    };

    _this.handleNotesChange = function (event) {
      var value = event.target.value;

      _this.setState({ notes: value });
    };

    _this.handleCancelButtonClick = function (event) {
      _this.props.onCloseModal();
    };

    _this.state = {
      currentOption: null,
      notes: props.notes
    };
    return _this;
  }

  (0, _createClass3.default)(SchedulingTime, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          subTitle = _props.subTitle,
          date = _props.date,
          onClickBackButton = _props.onClickBackButton,
          stepName = _props.stepName,
          logo = _props.logo,
          theme = _props.theme,
          timeRange = _props.timeRange;
      var _state = this.state,
          currentOption = _state.currentOption,
          notes = _state.notes;


      return _react2.default.createElement(
        'div',
        { className: _SchedulingTimeModule2.default.container },
        _react2.default.createElement(
          'div',
          { className: _SchedulingTimeModule2.default.cancelButtonWrapper },
          _react2.default.createElement(
            'button',
            {
              type: 'button',
              className: _SchedulingTimeModule2.default.cancelButton,
              onClick: this.handleCancelButtonClick
            },
            _react2.default.createElement(_reactFontawesome.FontAwesomeIcon, { icon: _proLightSvgIcons.faTimes, className: _SchedulingTimeModule2.default.cancelButton__icon })
          )
        ),
        _react2.default.createElement(_index2.default, {
          date: date,
          label: stepName + ' date is',
          classNames: { container: _SchedulingTimeModule2.default.moveInDateContainer },
          theme: theme
        }),
        _react2.default.createElement(
          'div',
          { className: _SchedulingTimeModule2.default.header },
          _react2.default.createElement(
            'div',
            { className: _SchedulingTimeModule2.default.logoWrapper },
            _react2.default.createElement('img', { className: _SchedulingTimeModule2.default.logo, src: logo.link, alt: 'logo of ' + logo.name + ' provider' })
          ),
          _react2.default.createElement(
            'span',
            { className: _SchedulingTimeModule2.default.header__title },
            'Select a Time'
          ),
          _react2.default.createElement(
            'span',
            { className: _SchedulingTimeModule2.default.header__subTitle },
            subTitle
          )
        ),
        _react2.default.createElement(
          'div',
          { className: _SchedulingTimeModule2.default.selection },
          _react2.default.createElement(
            'ul',
            { className: _SchedulingTimeModule2.default.selection__list },
            timeRange.options.map(function (option) {
              return _react2.default.createElement(
                'li',
                { className: _SchedulingTimeModule2.default.selection__item, key: option.value },
                _react2.default.createElement('input', {
                  className: _SchedulingTimeModule2.default.selection__itemInput,
                  type: 'radio',
                  id: option.value,
                  name: 'selector',
                  onChange: _this2.handleTimeOptionChange(option.value)
                }),
                _react2.default.createElement(
                  'label',
                  { className: _SchedulingTimeModule2.default.selection__itemLabel, htmlFor: option.value },
                  _react2.default.createElement(
                    'span',
                    { className: _SchedulingTimeModule2.default.selection__labelImportant },
                    option.label
                  )
                )
              );
            })
          ),
          _react2.default.createElement('textarea', {
            className: _SchedulingTimeModule2.default.selection__textarea,
            placeholder: 'Leave a note about your schedule... (optional)',
            onChange: this.handleNotesChange,
            value: notes
          })
        ),
        _react2.default.createElement(_index4.default, {
          valueSet: 'Set Time',
          isSelectedValue: !!currentOption,
          onSubmit: this.handleSubmit,
          onClickBackButton: onClickBackButton,
          customClassName: _SchedulingTimeModule2.default.footer,
          theme: theme
        })
      );
    }
  }]);
  return SchedulingTime;
}(_react2.default.PureComponent);

SchedulingTime.defaultProps = {
  notes: ''
};

exports.default = SchedulingTime;